diff --git a/src/backend/storage/ipc/standby.c b/src/backend/storage/ipc/standby.c
index 92d9027776..b690c86637 100644
--- a/src/backend/storage/ipc/standby.c
+++ b/src/backend/storage/ipc/standby.c
@@ -620,11 +620,15 @@ StandbyTimeoutHandler(void)
 
 /*
  * StandbyLockTimeoutHandler() will be called if STANDBY_LOCK_TIMEOUT is exceeded.
- * This doesn't need to do anything, simply waking up is enough.
+ * This doesn't set flag, simply waking up is enough.
  */
 void
 StandbyLockTimeoutHandler(void)
 {
+	int			save_errno = errno;
+
+	SetLatch(MyLatch);
+	errno = save_errno;
 }
 
 /*
